include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext AsciiPatternSource_, MonoPatternSource_, ColorPatternSource_
ext VVramFront_, RowFlags_

VramTop equ Vram

dseg
Backup:                                 public Backup
    defs VVramWidth*VVramHeight

cseg
; ToRam:
; 	;64K RAM
;     push af
;         ld a,(0e6c2h)
;         or 2
;         out (31h),a
;         ld (0e6c2h),a
;     pop af
; ret

; ToRom:
; 	;N88 ROM
;     push af
;         ld a,(0e6c2h)
;         and not 2
;         out (31h),a
;         ld (0e6c2h),a
;     pop af
; ret


MakeDouble:
    ld bc,0c000h
    do
        rlca
        if c
            ex af,af'
                ld a,c
                or b
                ld c,a
            ex af,af'
        endif
        srl b | srl b
    while nz | wend
ret


; void InitAsciiPattern();
cseg
InitAsciiPattern_: public InitAsciiPattern_
    push af | push hl | push de | push bc
        di
            ;call ToRam
            ld hl,AsciiPatternRam
            ld de,AsciiPatternSource_
            ld bc,CharHeight*AsciiCount
            do
                push bc
                    ld a,(de) | inc de
                    call MakeDouble
                    ld (hl),c | inc hl
                    call MakeDouble
                    ld (hl),c | inc hl
                pop bc
                dec bc
                ld a,c
                or b
            while nz | wend
            ;call ToRom
        ei
    pop bc | pop de | pop hl | pop af
ret


; void InitMonoPattern();
cseg
Colors:
    defb 4,05h
    defb 3,07h
    defb 1,06h
    defb 0
InitMonoPattern_: public InitMonoPattern_
    push af | push hl | push de | push bc
        di
            ;call ToRam
            ld hl,PatternRam
            ld de,MonoPatternSource_
            ld bc,Colors
            do
                ld a,(bc) | inc bc
                or a
            while nz
                exx
                    ld e,a
                exx
                ld a,(bc) | inc bc
                push bc
                    exx
                        ld b,a
                        ld a,e
                    exx
                    ld b,a
                    do
                        exx
                            ld d,b
                        exx
                        ld c,3
                        do
                            push de | push bc
                                ld b,4
                                do
                                    ld a,(de)
                                    exx
                                        ld e,0
                                        bit 0,d
                                        if nz
                                            or e
                                            ld e,a
                                        endif
                                    exx
                                    ld a,(de) | inc de
                                    exx
                                        bit 4,d
                                        if nz
                                            cpl
                                            or e
                                            ld e,a
                                        endif
                                        ld a,e
                                    exx
                                    push bc
                                        call MakeDouble
                                        ld (hl),c | inc hl
                                        call MakeDouble
                                        ld (hl),c | inc hl
                                    pop bc
                                dwnz
                            pop bc | pop de
                            exx
                                srl d
                            exx
                            dec c
                        while nz | wend
                        push bc
                            ex de,hl
                                ld bc,CharHeight/2
                                add hl,bc
                            ex de,hl
                        pop bc
                    dwnz
                pop bc
            wend
            ;call ToRom
        ei
    pop bc | pop de | pop hl | pop af
ret


; void InitColorPattern();
cseg
InitColorPattern_: public InitColorPattern_
    push af | push hl | push de | push bc
        di
            ;call ToRam
            ld hl,PatternRam+CharHeight*3*Char_Enemy
            ld de,ColorPatternSource_
            ld bc,(Char_End-Char_Enemy)*CharHeight*3
            do
                push bc
                    ld a,(de) | inc de
                    call MakeDouble
                    ld (hl),c | inc hl
                    call MakeDouble
                    ld (hl),c | inc hl
                pop bc
                dec bc
                ld a,c
                or b
            while nz | wend
            ;call ToRom
        ei
    pop bc | pop de | pop hl | pop af
ret


; void ClearScreen();
ClearScreen_:   public ClearScreen_
    push af | push hl | push de | push bc
        di
            ld a,5ch
            do
                ld c,a
                out (c),a
                ld hl,0c000h
                ld de,0c001h
                ld bc,640/8*200-1
                ld (hl),0
                ldir
                inc a
                cp 5fh
            while nz | wend
            out (5fh),a
        ei

        ld hl,Backup
        ld bc,VVramWidth*VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret

cseg
PatternAddressDE:
    ex de,hl
        ld l,a
        ld h,0
        ld c,l
        ld b,h
        add hl,hl ;*2
        add hl,bc ;*3
        add hl,hl ;*6
        add hl,hl ;*12
        add hl,hl ;*24
        ld bc,PatternRam
        add hl,bc
    ex de,hl
ret


Put8:
    di
        ld a,5ch
        do
            ld (Put8Port+1),a
            Put8Port:
            out (0),a
            ld b,CharHeight
            do
                ld a,(de)
                inc de
                ld (hl),a
                ld a,l
                add a,VramWidth
                ld l,a
                ld a,h
                adc a,0
                ld h,a
            dwnz
            ld bc,-VramWidth*CharHeight
            add hl,bc
            ld a,(Put8Port+1)
            inc a
            cp 5fh
        while nz | wend
        out (5fh),a
    ei
ret


Put4:
    di
        ld a,5ch
        do
            ld (Put4Port+1),a
            Put4Port:
            out (0),a
            ld b,CharHeight/2
            do
                ld a,(de)
                inc de
                ld (hl),a
                ld a,l
                add a,VramWidth
                ld l,a
                ld a,h
                adc a,0
                ld h,a
            dwnz
            inc de | inc de | inc de | inc de
            ld bc,-VramWidth*CharHeight/2
            add hl,bc
            ld a,(Put4Port+1)
            inc a
            cp 5fh
        while nz | wend
        out (5fh),a
    ei
ret


Clear8:
    di
        ld c,5ch
        do
            out (c),a
            ld b,CharHeight
            do
                ld (hl),0
                ld a,l
                add a,VramWidth
                ld l,a
                ld a,h
                adc a,0
                ld h,a
            dwnz
            ld a,c
            ld bc,-VramWidth*CharHeight
            add hl,bc
            inc a
            ld c,a
            cp 5fh
        while nz | wend
        out (5fh),a
    ei
ret


Clear4:
    di
        ld c,5ch
        do
            out (c),a
            ld b,CharHeight/2
            do
                ld (hl),0
                ld a,l
                add a,VramWidth
                ld l,a
                ld a,h
                adc a,0
                ld h,a
            dwnz
            ld a,c
            ld bc,-VramWidth*CharHeight/2
            add hl,bc
            inc a
            ld c,a
            cp 5fh
        while nz | wend
        out (5fh),a
    ei
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    push af | push hl | push de | push bc
        ld a,e
        call PatternAddressDE
        di
            ;call ToRam
            call Put8
            ;call ToRom
        ei
    pop bc | pop de | pop hl | pop af
    inc hl
ret


VVramToVramRow:
    exx
        push de | push bc
    exx

    ld b,VVramWidth/2
    do 
        push bc
            ld a,(de) | inc de
            ld c,a
            cp (hl)
            if nz
                ld (hl),a | inc hl
                ld a,(de) | inc de
                ld b,a
                ld (hl),a | inc hl
                jr rowput
            else
                inc hl
                ld a,(de) | inc de
                ld b,a
                cp (hl)
                if nz
                    ld (hl),a | inc hl
                    rowput:
                    ld a,c
                    or a
                    if z
                        exx
                            call Clear8                    
                        exx
                    else
                        exx
                            call PatternAddressDE
                        exx
                        ld a,b
                        exx
                            push hl
                                or a
                                if z
                                    call Put8
                                    jr rowputend
                                endif
                                dec a
                                if z
                                    call Clear4
                                    ld bc,VramRowSize/2
                                    add hl,bc
                                    call Put4
                                    jr rowputend
                                endif
                                dec a
                                if z
                                    push de
                                        inc de | inc de | inc de | inc de
                                        call Put4
                                    pop de
                                    ex de,hl
                                        ld bc,CharHeight*3*4
                                        add hl,bc
                                    ex de,hl
                                    ld bc,VramRowSize/2
                                    add hl,bc
                                    call Put4
                                else
                                    inc de | inc de | inc de | inc de
                                    call Put4
                                    ld bc,VramRowSize/2
                                    add hl,bc
                                    call Clear4
                                endif
                                rowputend:
                            pop hl
                        exx
                    endif
                else
                    inc hl
                endif
                exx
                    inc hl
                exx
            endif
        pop bc
    dwnz
    exx
        ld bc,VramRowSize-VVramWidth/2
        add hl,bc

        pop bc | pop de
    exx
ret


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,Vram
        exx
        ld c,VVramHeight
        do
            call VVramToVramRow
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,Vram
            ld de,RowFlags_
            ex de,hl
                ld c,1
                ld b,(hl)
                inc hl
            ex de,hl
        exx
        ld c,VVramHeight ; vertical count    
        do
            exx
                ld a,b
                and c
            exx
            if nz
                call VVramToVramRow            
            else
                push bc
                    ld bc,VVramWidth
                    add hl,bc
                    ex de,hl
                        add hl,bc
                    ex de,hl
                pop bc
                exx
                    push bc
                        ld bc,VramRowSize
                        add hl,bc
                    pop bc
                exx
            endif
            exx
                sla c
                if z
                    ex de,hl
                        ld c,1
                        ld b,(hl)
                        inc hl
                    ex de,hl
                endif
            exx
            dec c
        while nz | wend

        xor a
        ld (RowFlags_),a
        ld (RowFlags_+1),a
        ld (RowFlags_+2),a
    pop bc | pop de | pop hl | pop af
ret


; word PrintC(word vram, byte c);
PrintC_: public PrintC_
    push af | push hl | push de | push bc
        ld a,e
        sub ' '
        add a,a ;*2
        add a,a ;*4
        ex de,hl
            ld l,a
            ld h,0
            add hl,hl ;*8
            add hl,hl ;*16
            ld bc,AsciiPatternRam
            add hl,bc
        ex de,hl
        di
            ;call ToRam

            ld b,CharHeight
            do
                push bc
                    ld a,(de) | inc de
                    ld b,a
                    ld a,(de) | inc de
                    ld c,a

                    out (5ch),a
                    ld (hl),b | inc hl
                    ld (hl),c | dec hl
                    out (5dh),a
                    ld (hl),b | inc hl
                    ld (hl),c | dec hl
                    out (5eh),a
                    ld (hl),b | inc hl
                    ld (hl),c | dec hl

                    out (5fh),a
                    ld bc,VramWidth
                    add hl,bc
                pop bc
            dwnz
            ;call ToRom
        ei
    pop bc | pop de | pop hl | pop af
    inc hl | inc hl
ret